#include "Adafruit_VL53L0X.h"

const int ledPin = LED_BUILTIN;
int ledState = 0;

Adafruit_VL53L0X lox = Adafruit_VL53L0X();

void setup() {
  pinMode(ledPin, OUTPUT);
  
  Serial.begin(115200);

  // wait until serial port opens for native USB devices
  while (! Serial) {
    delay(1);
  }

  if (!lox.begin()) {
    Serial.println(F("Error: Failed to boot VL53L0X"));
    //while(1);
  }
}

void loop() {
  ledState = recvSerial();
  if (ledState == 1)
  {
    digitalWrite(ledPin, HIGH);
  }
  else if (ledState == 0)
  {
    digitalWrite(ledPin, LOW);
  }

  VL53L0X_RangingMeasurementData_t measure;
  lox.rangingTest(&measure, false); // pass in 'true' to get debug data printout!
  
  if (measure.RangeStatus != 4) {  // phase failures have incorrect data
    Serial.println(measure.RangeMilliMeter);
  } else {
    Serial.println(0x00);
  }
  delay(100);
}

int recvSerial() {
  if (Serial.available()) {
    int serialData = Serial.read();
    switch (serialData) {
      case '1':
        return 1;
        break;
      case '0':
        return 0;
        break;
      default:
        return -1;
    }
  }
}
